<template>
  <q-layout view="hHh lpR fFf" class="bg-grey-1">
    <q-header elevated class="bg-primary text-white q-py-xs" height-hint="58">
      <q-toolbar>
        <q-btn
          flat
          dense
          aria-label="Menu"
          icon="fa-solid fa-bars"
          @click="toggleLeftDrawer"
        />

        <q-btn v-if="$q.screen.gt.xs" flat no-caps no-wrap class="q-ml-xs">
          <q-toolbar-title shrink class="text-weight-bold">
            StreetViewer
          </q-toolbar-title>
        </q-btn>

        <q-space />

        <div class="q-gutter-sm row items-center no-wrap">
          <q-btn round dense flat color="white" icon="fa-solid fa-bell">
            <q-tooltip>Notifications</q-tooltip>
          </q-btn>
        </div>
      </q-toolbar>
    </q-header>

    <q-drawer
      v-model="leftDrawerOpen"
      show-if-above
      bordered
      class="bg-grey-2"
      :width="240"
    >
      <q-scroll-area class="fit">
        <q-list padding>
          <q-item
            v-ripple
            clickable
            to="/"
            name="home"
            active-class="SV__menu-active"
            exact
          >
            <q-item-section avatar>
              <q-icon color="grey" name="fa-solid fa-house-chimney" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Home</q-item-label>
            </q-item-section>
          </q-item>

          <q-item
            v-ripple
            clickable
            to="/import"
            name="import"
            active-class="SV__menu-active"
            exact
          >
            <q-item-section avatar>
              <q-icon color="grey" name="fa-solid fa-file-import" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Import</q-item-label>
            </q-item-section>
          </q-item>

          <q-item
            v-ripple
            clickable
            to="/history"
            name="history"
            active-class="SV__menu-active"
            exact
          >
            <q-item-section avatar>
              <q-icon color="grey" name="fa-solid fa-list-timeline" />
            </q-item-section>
            <q-item-section>
              <q-item-label>History</q-item-label>
            </q-item-section>
          </q-item>

          <q-separator class="q-mt-md q-mb-lg" />

          <q-item
            v-ripple
            clickable
            to="/settings"
            name="settings"
            active-class="SV__menu-active"
            exact
          >
            <q-item-section avatar>
              <q-icon color="grey" name="fa-solid fa-gear" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Settings</q-item-label>
            </q-item-section>
          </q-item>

          <q-item
            v-ripple
            clickable
            to="/help"
            name="help"
            active-class="SV__menu-active"
            exact
          >
            <q-item-section avatar>
              <q-icon color="grey" name="fa-solid fa-circle-question" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Help</q-item-label>
            </q-item-section>
          </q-item>

          <q-separator class="q-mt-md q-mb-lg" />

          <div class="q-px-md text-grey-9">
            <div class="row items-center q-gutter-x-sm q-gutter-y-xs">
              <a
                key="about"
                class="SV__drawer-footer-link"
                href="javascript:void(0)"
                @click="about = true"
                >About</a
              >
              <span class="SV__version">Version {{ applicationVersion }}</span>
            </div>
          </div>
        </q-list>
      </q-scroll-area>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>
  </q-layout>

  <q-dialog v-model="about" persistent>
    <q-layout
      view="hhh lpr fff"
      container
      class="bg-white text-dark"
      style="height: 775px"
    >
      <q-header class="bg-primary">
        <q-toolbar>
          <q-toolbar-title>About</q-toolbar-title>
          <q-btn v-close-popup flat dound dense icon="fa-solid fa-xmark" />
        </q-toolbar>
      </q-header>

      <q-page-container>
        <q-page padding>
          <div class="column">
            <div class="row fit justify-center">
              <img
                alt="StreetViewer"
                src="streetviewer.svg"
                style="width: 100%"
              />
            </div>

            <div class="q-mb-md row justify-right SV__version">
              Version {{ applicationVersion }}
            </div>

            <div class="q-mb-sm row">
              Copyright &copy; 2023&nbsp;
              <a href="https://widgitlabs.com" target="_blank">Widgit Labs</a>
            </div>

            <div class="q-mb-md row">
              <a
                href="(https://gitlab.com/widgitlabs/nodejs/streetviewer/blob/main/license.txt"
                target="_blank"
                class="q-mr-sm"
              >
                <img
                  src="https://img.shields.io/badge/license-GPL--3.0%2B-blue.svg"
                />
              </a>

              <a
                href="https://gitlab.com/nodejs/streetviewer/cartography/pipelines"
                target="_blank"
                class="q-mr-sm"
              >
                <img
                  src="https://gitlab.com/widgitlabs/nodejs/streetviewer/badges/main/pipeline.svg"
                />
              </a>
            </div>

            <q-separator spaced color="grey10" />

            <div class="q-mb-md q-mt-md row weight-bold">Built With:</div>

            <div class="q-mb-md row">
              <q-scroll-area class="SV__dependencies">
                <div
                  v-for="(value, name) in applicationDeps"
                  :key="name"
                  class="row"
                >
                  <div class="col">{{ name }}</div>
                  <div class="col text-right">
                    {{ value }}
                  </div>
                </div>
              </q-scroll-area>
            </div>
          </div>
        </q-page>
      </q-page-container>
    </q-layout>
  </q-dialog>
</template>

<script>
import { ref } from "vue";
import { version } from "../../package.json";
import { dependencies } from "../../package.json";
import { devDependencies } from "../../package.json";

export default {
  name: "MainLayout",

  setup() {
    const leftDrawerOpen = ref(false);

    function toggleLeftDrawer() {
      leftDrawerOpen.value = !leftDrawerOpen.value;
    }

    return {
      leftDrawerOpen,

      toggleLeftDrawer,

      about: ref(false),
    };
  },

  data() {
    function getDependencies() {
      let theDependencies = Object.assign(dependencies, devDependencies);

      theDependencies = sortDependencies(theDependencies);

      return theDependencies;
    }

    function sortDependencies(deps) {
      return Object.keys(deps)
        .sort()
        .reduce(function (result, key) {
          result[key] = deps[key];

          return result;
        }, {});
    }

    return {
      applicationVersion: version,
      applicationDeps: getDependencies(),
    };
  },
};
</script>

<style lang="sass">
.SV

  &__toolbar-input-container
    min-width: 100px
    width: 55%

  &__toolbar-input-btn
    border-radius: 0
    border-style: solid
    border-width: 1px 1px 1px 0
    border-color: rgba(0,0,0,.24)
    max-width: 60px
    width: 100%

  &__drawer-footer-link
    color: inherit
    text-decoration: none
    font-weight: 500
    font-size: .75rem

  &__version
    font-weight: 700
    font-size: .7rem
    margin-left: auto

    &:hover
      color: #000

  &__menu-active
    color: #23a565

  &__dependencies
    border: 1px solid rgba(0,0,0,.24)
    border-radius: 0.5rem
    height: 370px
    padding: 1em
    width: 100%
</style>
